<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsMember2 extends JPlugin
{
	function plgAnalyticsMember2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once (JPATH_ROOT .DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'controllers'.DS.'cnf.php');
		jimport('joomla.filesystem.file');
		JcsControllerCnf::initialyze();
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'member2') return;
		
		$data = array('ampie');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'member2') return;
		global $mainframe;
	    if( !JComponentHelper::isEnabled('com_jcs', true) )
		{
		    $errors = '<h3>Mighty Membership Component Not Exists or Not Enabled<h3>';
			return;
		}
	    
		$view_type = $params->get('view_type');
        
		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		if( $view_type == 'total') {
		    $objChart->setConfig('data_labels.show',"<![CDATA[{title}: <b>{percents}%</b>]]> ");
        	$objChart->setConfig('legend.values.text','<![CDATA[<b>${value}</b> (<i>{percents}%</i>)]]>');
		    $objChart->setConfig('balloon.show','<![CDATA[{title}: ${value}. (<b>{percents}%</b>)]]>');
        	
    		$objChart->addLabel("<![CDATA[This graph shows sale income relationship between subscription plans]]>",20 ,385 , array('text_size' => 10));
    		$objChart->addLabel("<![CDATA[<b>Subscription Plans Relationship</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
		    $objChart->setConfig('data_labels.show',"<![CDATA[{title}: <b>{percents}%</b>]]> ");
        	$objChart->setConfig('legend.values.text','<![CDATA[<b>${value}</b> (<i>{percents}%</i>)]]>');
		    $objChart->setConfig('balloon.show','<![CDATA[{title}: ${value}. (<b>{percents}%</b>)]]>');
        	
		    $objChart->addLabel("<![CDATA[This graph shows amount of transactions relationship for every plan]]>",20 ,385 , array('text_size' => 10));
    		$objChart->addLabel("<![CDATA[<b>Plan Transaction Count Relationship</b>]]>",15 ,25 , array('text_size' => 16));
		}
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'member2' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if($name != 'member2') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "SELECT b.name,  ROUND(sum(i.price), 2) AS total, COUNT(i.id) as amount
		FROM #__jcs_plans AS b
		LEFT JOIN #__jcs_user_subscr AS i ON i.subscription_id = b.id
		WHERE i.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND i.ctime < '$to'
		AND i.published = 1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND i.user_id = '$user_id'";
		$sql .= "
		GROUP BY b.id
		ORDER BY total  DESC
		";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;
		
    	$view_type = $params->get('view_type');
	    foreach ( $result AS $row ) {
			$slices[$row->name] = $row->$view_type;
		}
		$pull = true;
		foreach ($slices AS $k => $row)
		{
			if( $pull ) { 
			    $pulout = 'true';
			    $pull = false;
			} 
			else $pulout = 'false';
			$objChart->addSlice($k, $row, array( 'pull_out' => $pulout, 'alpha' => 95) );
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'member2') return;

		$view_type = $params->get('view_type');

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		
		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "SELECT b.name,  ROUND(sum(i.price), 2) AS total, COUNT(i.id) as amount
		FROM #__jcs_plans AS b
		LEFT JOIN #__jcs_user_subscr AS i ON i.subscription_id = b.id
		WHERE i.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND i.ctime < '$to'
		AND i.published = 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND i.user_id = '$user_id'";
		$sql .= "
		GROUP BY b.id
		ORDER BY ".($sort_by ? $sort_by : 'total  DESC');
		if($limit)
		$sql .= " LIMIT 0, $limit";
		$db->setQuery($sql); //echo $db->_sql.'<Br><br>';
		$result = $db->loadObjectList();

		if(!$result) return;

		$k = 0;
		$total = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Subscription Name').'</th>';
		$out[] = '<th width="1%">'.JText::_('Total').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ($result AS $var => $row)
		{
			$k = 1 - $k;
			$out[] = sprintf("<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
			$k, $var + 1, $row->name, ($view_type == 'total' ? '$'.round($row->total, 2) : $row->amount)
			);//num/date/title/unit price/count/total
			$total += ($view_type == 'total' ? $row->total : $row->amount);
		}
		$out[] = '
			<tr>
				<td colspan="2" align="right"><b>'.JText::_('Total').'</b></td>
				<td><b><big>'.($view_type == 'total' ? '$'.round($total, 2) : $total).'</big></b></td>
			</tr>
		</tbody></table>';

		$table = implode("", $out);

		if($params->get('rep_xls'))
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'member2') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}
		$totals = array();

		$sql = "SELECT count(*)
		FROM #__jcs_user_subscr AS p
		LEFT JOIN #__jcs_plans AS b	ON b.id = p.subscription_id
		WHERE p.published = 1 ".($ids ? " AND b.id IN ($ids) " : null);
		if( ( $params->get('user_stick') || $user->gid == 25 ) && $user_id )
		$sql .= " AND p.user_id = '$user_id'";
		$db->setQuery($sql);
		if($res = $db->loadResult())
		{
			$totals[0]['value'] = $res;
			$totals[0]['text'] = JText::_('Total Subscription in DB');
		}

		$sql = "SELECT count(*)
		FROM #__jcs_user_subscr AS p
		LEFT JOIN #__jcs_plans AS b	ON b.id = p.subscription_id
		WHERE p.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND p.ctime < '$to'
		AND p.published = 1
		";
		if( ( $params->get('user_stick') || $user->gid == 25 ) && $user_id )
		$sql .= " AND p.user_id = '$user_id'";
		$db->setQuery($sql);
		if($res = $db->loadResult())
		{
			$totals[1]['value'] = $res;
			$totals[1]['text'] = JText::_('Total Subscription in this report');
		}
		$sql = "SELECT ROUND(sum(p.price), 2)
		FROM #__jcs_user_subscr AS p
		LEFT JOIN #__jcs_plans AS b	ON b.id = p.subscription_id
		WHERE p.ctime > '$from'".
		($ids ? " AND b.id IN ($ids) " : null)
		."AND p.ctime < '$to'
		AND p.published = 1
		";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND p.user_id = '$user_id'";
		$db->setQuery($sql);
		if($res = $db->loadResult())
		{
			$totals[2]['value'] = str_replace(array("00", "Sign"), array($res, JCS_GENERAL_CURR), JCS_LAYOUT_PRICE);
			$totals[2]['text'] = JText::_('Total Price in report');
		}

		return $totals;
	}
}
?>