<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsMember3 extends JPlugin
{
	function plgAnalyticsMember3( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once (JPATH_ROOT .DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'controllers'.DS.'cnf.php');
		jimport('joomla.filesystem.file');
		JcsControllerCnf::initialyze();
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'member3') return;
		
		$data = array('amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'member3') return;
		global $mainframe;
	    if( !JComponentHelper::isEnabled('com_jcs', true) )
		{
		    $errors = '<h3>Mighty Membership Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('type','stacked');
		$objChart->setConfig('depth','10');
		$objChart->setConfig('angle','15');
		$objChart->setConfig('column.type','stacked');
		$objChart->setConfig('column.width','70');
		$objChart->setConfig('column.alpha','90');
		$objChart->setConfig('column.grow_effect','strong');
		$objChart->addLabel("<![CDATA[This graph shows how many days take the period between registration and subscribing for users]]>",20 ,385 , array('text_size' => 10));
		$objChart->addLabel("<![CDATA[<b>Users subscribing speed</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'member3' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if($name != 'member3') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "SELECT TO_DAYS(s.ctime) - TO_DAYS(u.registerDate) as days_count,
		DAYOFYEAR(s.ctime) as sday,
		WEEKOFYEAR(s.ctime) as sweek,
		MONTH(s.ctime) AS smonth,
		DATE_FORMAT(s.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(s.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(s.ctime , '%b') AS dat_smonth 
		FROM #__jcs_user_subscr s
		JOIN #__users u ON u.id = s.user_id 
		WHERE s.published = '1' AND u.block = 0 ".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		$sql .= "
		GROUP BY s.id, `{$groupby}`
		ORDER BY s.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result || !count($result)) return;

		$totals = array();

		foreach ($result AS $key => $row)
		{
			if(!isset($totals[$row->{"dat_".$groupby}])) $totals[$row->{"dat_".$groupby}] = array_fill(0, 8, 0);
			$series[] = $row->{"dat_".$groupby};
			if($row->days_count < 2)
			$group = 0;
			else if($row->days_count > 1 && $row->days_count < 4)
			$group = 1;
			else if($row->days_count > 3 && $row->days_count < 8)
			$group = 2;
			else if($row->days_count > 7 && $row->days_count < 31)
			$group = 3;
			else if($row->days_count > 30 && $row->days_count < 61)
			$group = 4;
			else if($row->days_count > 60 && $row->days_count < 91)
			$group = 5;
			else if($row->days_count > 90 && $row->days_count < 181)
			$group = 6;
			else
			$group = 7;

			if(isset($totals[$row->{"dat_".$groupby}][$group]))
			$totals[$row->{"dat_".$groupby}][$group] ++ ;
			else
			$totals[$row->{"dat_".$groupby}][$group] = 1;
				
		}
		$tmp = array_unique($series);
		$series = array();
		$k = 1;
		$graphs = array();
		$amount = array();
		foreach ($tmp as $val)
		{
            $objChart->addSerie($k, $val);
			$amount[$val] = isset($amount[$val] ) ? $amount[$val] + array_sum($totals[$val]) : array_sum($totals[$val]);
			foreach ($totals[$val] as $key => $count)
			{
				$graphs[$key][$k] = $count;
			}
			$k++;
		}
		$k = 1;
		foreach ($amount as $key => $count)
		{
			$graphs0[$k] = $count;
			$k ++;
		}

		$i=0;
		$objChart->addGraph(0, JText::_('Sales total'), $graphs0, array( 
			'balloon_text' => "<![CDATA[{title}: {value} ".JText::_('subscriptions')." on {series}]]>",
			'color' => '#FFA94D',
			'bullet' => 'round',
		    'type' => 'line'
		));
		
		if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('1 day'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#FF0000',
		        'balloon_text_color' => '#FFFFFF',
    			'axis' => 'left',
		        'data_labels' => '<![CDATA[{value}]]>'
    		));
		}
	    if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('3 days'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#FF6600',
		        'color_hover' => '#586835',
		        'bullet' => 'square',
    			'axis' => 'right',
		    	'balloon_text_color' => '#000000'
    		));
		}
	    if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('1 week'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#FFF000',
		        'color_hover' => '#0033cc',
		        'line_alpha' => '30',
		        'fill_alpha' => '5',
		        'fill_color' => '#003399',
		        'bullet' => 'square',
		    	'balloon_text_color' => '#000000'
    		));
		}
    	if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('1 month'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#65D42E',
		        'color_hover' => '#996699',
		        'line_alpha' => '30',
		        'selected' => 'false',
		        'fill_color' => '#003399',
		        'bullet' => 'square',
		    	'balloon_text_color' => '#000000'
    		));
		}
    	if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('1 month'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#65D42E',
		        'color_hover' => '#996699',
		        'line_alpha' => '30',
		        'selected' => 'false',
		    	'balloon_text_color' => '#000000'
    		));
		}
	    if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('2 months'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#00EAFF',
		        'color_hover' => '#0033cc',
		        'line_alpha' => '30',
		    	'fill_alpha' => '5',
		        'fill_color' => '#003399',
		    	'balloon_text_color' => '#000000'
    		));
		}
	    if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('3 months'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#0060FF',
		        'color_hover' => '#996699',
		        'line_alpha' => '30',
		    	'balloon_text_color' => '#FFFFFF'
    		));
		}
	    if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('6 months'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#46A348',
		    	'balloon_text_color' => '#FFFFFF'
    		));
		}
	    if (isset($graphs[$i]) && count($graphs[$i])) {
		    $objChart->addGraph(++$i, JText::_('More than 6 months'), $graphs[$i++], array( 
    			'balloon_text' => "<![CDATA[{value} subscriptions: {percents}%]]>",
    			'color' => '#DB2EC5',
    			'axis' => 'right',
		    	'balloon_text_color' => '#FFFFFF'
    		));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'member3') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');
		$limit = $params->get('limit', 0);

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "SELECT TO_DAYS(s.ctime) - TO_DAYS(u.registerDate) as days_count, pl.name, pl.id, s.id as sid,
		DAYOFYEAR(s.ctime) as sday,
		WEEKOFYEAR(s.ctime) as sweek,
		MONTH(s.ctime) AS smonth,
		DATE_FORMAT(s.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(s.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(s.ctime , '%b') AS dat_smonth 
		FROM #__jcs_user_subscr s
		JOIN #__jcs_plans pl ON s.subscription_id = pl.id
		JOIN #__users u ON u.id = s.user_id 
		WHERE s.published = '1' AND u.block = 0 ".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		$sql .= "
		GROUP BY s.id, `{$groupby}`
		ORDER BY s.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		$sql = "SELECT COUNT(*)
		FROM #__jcs_user_subscr s
		JOIN #__users u ON u.id = s.user_id 
		WHERE s.published = '1' AND u.block = 0 ".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";

		$db->setQuery($sql);
		$db_totals = $db->loadResult();

		if(!$result && !$db_totals) return;

		$totals = array();

		foreach ($result AS $key => $row)
		{
			$totals[$row->{"dat_".$groupby}][$row->sid] = $row;
		}
		$result = array();
		foreach ($totals as $p => $val)
		{
			foreach ($val as $row)
			{
				if($row->days_count < 2)
				$group = 0;
				else if($row->days_count > 1 && $row->days_count < 4)
				$group = 1;
				else if($row->days_count > 3 && $row->days_count < 8)
				$group = 2;
				else if($row->days_count > 7 && $row->days_count < 31)
				$group = 3;
				else if($row->days_count > 30 && $row->days_count < 61)
				$group = 4;
				else if($row->days_count > 60 && $row->days_count < 91)
				$group = 5;
				else if($row->days_count > 90 && $row->days_count < 181)
				$group = 6;
				else
				$group = 7;
				if(isset($result[$p][$row->name]))
				{
					$result[$p][$row->name][$group] = isset($result[$p][$row->name][$group]) ? $result[$p][$row->name][$group] + 1 : 1;
				}
				else
				$result[$p][$row->name][$group] = 1;

			}
		}
		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Subscription Plan').'</th>';
		$out[] = '<th width="1%" nowrap>'.JText::_('Count').'</th>';
		$out[] = '<th width="1%">'.JText::_('Speed').'</th>';
		$out[] = '<th width="1%">'.JText::_('Date').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$groups = array('1 day', '3 days', '1 week', '1 month', '2 months', '3 months', '6 months', 'More than 6 months');
		$i = 1;
		$k = 0;
		$total = 0;
		foreach ($result AS $date => $row)
		{
			foreach ($row as $plan => $val)
			{
				foreach ($val as $group => $count)
				{
					if ($limit && $i > $limit) break;
					$k = 1 - $k;
					$out[] = '<tr class="row'.$k.'">
					<td>'.$i.'</td>
					<td>'.$plan.'</td>
					<td align="center">'.$count.'</td>
					<td nowrap>'.JText::_($groups[$group]).'</td>
					<td nowrap>'.$date.'</td></tr>';
					$k ++; $i ++;
					$total += $count;
				}
			}
		}
		$out[] = '<tr><td colspan="2" align="right"><b>'.JText::_('Total').'</b></td>
			<td nowrap align="center"><b><big>'.$total.'</big></b></td>
			<td></td><td></td>
			</tr>';
		$out[] = '</tbody></table>';

		$table = implode("", $out);
		if($params->get('rep_xls'))
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'member3') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}
		$sql = "SELECT TO_DAYS(s.ctime) - TO_DAYS(u.registerDate) as days_count, pl.name, pl.id, s.id as sid,
		DAYOFYEAR(s.ctime) as sday,
		WEEKOFYEAR(s.ctime) as sweek,
		MONTH(s.ctime) AS smonth,
		DATE_FORMAT(s.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(s.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(s.ctime , '%b') AS dat_smonth 
		FROM #__jcs_user_subscr s
		JOIN #__jcs_plans pl ON s.subscription_id = pl.id
		JOIN #__users u ON u.id = s.user_id 
		WHERE s.published = '1' AND u.block = 0 ".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		$sql .= "
		GROUP BY s.id, `{$groupby}`
		ORDER BY s.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		$sql = "SELECT COUNT(*)
		FROM #__jcs_user_subscr s
		JOIN #__users u ON u.id = s.user_id 
		WHERE s.published = '1' AND u.block = 0 ".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";

		$db->setQuery($sql);
		$rep_totals = $db->loadResult();

		$sql = "SELECT COUNT(*)
		FROM #__jcs_user_subscr s
		JOIN #__users u ON u.id = s.user_id 
		WHERE s.published = '1' AND u.block = 0 ".
		($ids ? " AND s.subscription_id IN ($ids) " : null);
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";

		$db->setQuery($sql);
		$db_totals = $db->loadResult();

		if(!$rep_totals && !$db_totals) return;

		$totals = array();
		$groups = array_fill(0, 8, 0);

		foreach ($result AS $key => $row)
		{
			if($row->days_count < 2)
			$group = 0;
			else if($row->days_count > 1 && $row->days_count < 4)
			$group = 1;
			else if($row->days_count > 3 && $row->days_count < 8)
			$group = 2;
			else if($row->days_count > 7 && $row->days_count < 31)
			$group = 3;
			else if($row->days_count > 30 && $row->days_count < 61)
			$group = 4;
			else if($row->days_count > 60 && $row->days_count < 91)
			$group = 5;
			else if($row->days_count > 90 && $row->days_count < 181)
			$group = 6;
			else
			$group = 7;
			$groups[$group] ++;
		}

		$totals[0]['value'] = $db_totals;
		$totals[0]['text'] = JText::_('Subscriptions total in DB');

		$totals[1]['value'] = $rep_totals . ' <small><i>('.round($rep_totals / $db_totals * 100).'%)</i></small>';
		$totals[1]['text'] = JText::_('Subscriptions total in report');

		$totals[2]['value'] = $groups[0]. ' <small><i>'.JText::_('subscription(s)').' ('.round($groups[0] /$rep_totals * 100).'%)</i></small>';
		$totals[2]['text'] = JText::_('Purchasing speed').': 1 '.JText::_('day');

		$totals[3]['value'] = $groups[1]. ' <small><i>'.JText::_('subscription(s)').' ('.round($groups[1] /$rep_totals * 100).'%)</i></small>';
		$totals[3]['text'] = JText::_('Purchasing speed').': 3 '.JText::_('days');

		$totals[4]['value'] = $groups[2]. ' <small><i>'.JText::_('subscription(s)').' ('.round($groups[2] /$rep_totals * 100).'%)</i></small>';
		$totals[4]['text'] = JText::_('Purchasing speed').': 1 '.JText::_('week');

		return $totals;
	}
}
?>