<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsMember4 extends JPlugin
{
	function plgAnalyticsMember4( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once (JPATH_ROOT .DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'controllers'.DS.'cnf.php');
		jimport('joomla.filesystem.file');
		JcsControllerCnf::initialyze();
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'member4') return;
		
		$data = array('amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'member4') return;
		global $mainframe;
    	if( !JComponentHelper::isEnabled('com_jcs', true) )
		{
		    $errors = '<h3>Mighty Membership Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('type','100% stacked');
		$objChart->setConfig('depth','10');
		$objChart->setConfig('angle','15');
		$objChart->setConfig('column.type','100% stacked');
		$objChart->setConfig('column.width','70');
		$objChart->setConfig('column.alpha','100');
		$objChart->setConfig('column.grow_effect','strong');
		$objChart->addLabel("<![CDATA[This graph shows how many subscriptions users had when purchased a new subscription]]>",20 ,385 , array('text_size' => 10));
		$objChart->addLabel("<![CDATA[<b>Users subscribing history</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'member4' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';
	}

	function onChartData(&$objChart, $name, $params)
	{
		if($name != 'member4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "SELECT COUNT(*) as total, DAYOFMONTH(s.ctime) as mday, s.user_id, s.ctime,
		DAYOFYEAR(s.ctime) as sday,
		WEEKOFYEAR(s.ctime) as sweek,
		MONTH(s.ctime) AS smonth, YEAR(s.ctime) AS syear,
		DATE_FORMAT(s.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(s.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(s.ctime , '%b') AS dat_smonth 
		FROM #__jcs_user_subscr s		
		WHERE s.published = '1'".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		$sql .= "
		GROUP BY s.user_id, `{$groupby}`
		ORDER BY s.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result && !count($result)) return;

		$totals = array();

		foreach ($result AS $key => $row)
		{
			$index = $row->{"dat_".$groupby};
			$_result[$index][] = $row;
			switch ($groupby)
			{
				case 'sday':
					$query = " AND s.ctime < '".date("Y-m-d", strtotime($row->ctime))."'";
					break;
				case 'sweek':
					$query = " AND s.ctime < '".$row->ctime."'";
					$date = $row->syear.'-'.$row->smonth.'-'.($row->sweek);
					break;
				case 'smonth':
					$query = " AND s.ctime < '".$row->syear.'-'.$row->smonth.'-01'."'";
					break;
			}
			$_result[$index]['query'] = $query;
			$users[$index][] = $row->user_id;
		}
		$cols = array();
		foreach ($_result as $index => $row)
		{
			$objChart->addSerie($index, $index);
			$total = 0;
			foreach ($row as $val)
			$total += $val->total;
            $graph0[$index] = $total;
			$users[$index] = array_unique($users[$index]);

			$query = $row['query'];
			$sql = "SELECT COUNT(*) as total, s.user_id, s.ctime,
			DAYOFYEAR(s.ctime) as sday,
			WEEKOFYEAR(s.ctime) as sweek,
			MONTH(s.ctime) AS smonth, YEAR(s.ctime) AS syear
			FROM #__jcs_user_subscr s
			WHERE s.published = '1' AND s.user_id IN (".implode(', ', $users[$index]).")".
			($ids ? " AND s.subscription_id IN ($ids) " : null);
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND s.user_id = '$user_id'";
			$sql .= $query;
			$sql .= " GROUP BY s.user_id";
			$sql .= " ORDER BY s.ctime";
			$db->setQuery($sql);
			$res = $db->loadObjectList();

			$cols[$index]['total'] = 0;

			if($res)
			{
				foreach ($res as $val)
				{
					$cols[$index][$val->total][$val->user_id] = (isset($cols[$index][$val->total][$val->user_id]) ? $cols[$index][$val->total][$val->user_id] + 1 : 1);
					$cols[$index]['total'] += $val->total;
				}
			}
			else
			{
				foreach ($users[$index] as $user)
				$cols[$index][0][$user] = (isset($cols[$index][0][$user]) ? $cols[$index][0][$user] + 1 : 1);
			}
		}
		$k = 0;
		foreach ($cols as $date => $val)
		{
			$total = $val['total'];
			unset($val['total']);
			ksort($val);
			foreach ($val as $subscr => $users)
			{
				$msg = count($users).' '.(count($users) == 1 ? JText::_('user'): JText::_('users'));
				$msg .= ' '.JText::_('had').' ';
				$msg .= $subscr.' '.($subscr == 1 ? JText::_('subscription'): JText::_('subscriptions'));

                $graphs[$subscr][$date] = array('xid' => $date,'description' => $msg, 'value' => count($users));
			}
			$k ++;
		}
		
		$objChart->addGraph(1000, JText::_('Sales total'), $graph0, array( 
			'balloon_text' => "<![CDATA[{value} ".JText::_('subscriptions were purchased on')." {series}]]>",
			'color' => '#FFA94D',
			'bullet' => 'round',
		    'type' => 'line'
		));
		ksort($graphs);
		foreach( $graphs as $key => $graph ) {
			
			$objChart->addGraph($key, $key." ".JText::_('subscriptions'), $graph, array( 
    			'balloon_text' => "<![CDATA[{percents}%]]>",
    		    'type' => 'column'
    		));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'member4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');
		$limit = $params->get('limit', 0);

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}

		$sql = "SELECT COUNT(*) as total, DAYOFMONTH(s.ctime) as mday, s.user_id, s.ctime,
		DAYOFYEAR(s.ctime) as sday,
		WEEKOFYEAR(s.ctime) as sweek,
		MONTH(s.ctime) AS smonth, YEAR(s.ctime) AS syear,
		DATE_FORMAT(s.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(s.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(s.ctime , '%b') AS dat_smonth 
		FROM #__jcs_user_subscr s		
		WHERE s.published = '1'".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		$sql .= "
		GROUP BY s.user_id, `{$groupby}`
		ORDER BY s.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result && !count($result)) return;

		$totals = array();
		$_result = array();

		foreach ($result AS $key => $row)
		{
			$index = $row->{"dat_".$groupby};
			switch ($groupby)
			{
				case 'sday':
					$query = " AND s.ctime < '".date("Y-m-d", strtotime($row->ctime))."'";
					break;
				case 'sweek':
					$query = " AND s.ctime < '".$row->ctime."'";
					$date = $row->syear.'-'.$row->smonth.'-'.($row->sweek);
					break;
				case 'smonth':
					$query = " AND s.ctime < '".$row->syear.'-'.$row->smonth.'-01'."'";
					break;
			}
			$_result[$index][] = $row;
			$_result[$index]['query'] = $query;

			$users[$index][] = $row->user_id;
		}

		$cols = array();
		foreach ($_result AS $key => $row)
		{
			$index = $key;
			$users[$index] = array_unique($users[$index]);
			$query = $row['query'];
			$sql = "SELECT COUNT(*) as total, s.user_id, s.ctime,
			DAYOFYEAR(s.ctime) as sday,
			WEEKOFYEAR(s.ctime) as sweek,
			MONTH(s.ctime) AS smonth, YEAR(s.ctime) AS syear
			FROM #__jcs_user_subscr s
			WHERE s.published = '1' AND s.user_id IN (".implode(', ', $users[$index]).")".
			($ids ? " AND s.subscription_id IN ($ids) " : null);
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND s.user_id = '$user_id'";
			$sql .= $query;
			$sql .= " GROUP BY s.user_id";
			$sql .= " ORDER BY s.ctime";
			$db->setQuery($sql);
			$res = $db->loadObjectList();

			if($res)
			{
				foreach ($res as $val)
				{
					$cols[$index][$val->total][$val->user_id] = (isset($cols[$index][$val->total][$val->user_id]) ? $cols[$index][$val->total][$val->user_id] + 1 : 1);
				}
			}
			else
			{
				foreach($users[$index] as $user1)
				$cols[$index][0][$user1] = (isset($cols[$index][0][$user1]) ? $cols[$index][0][$user1] + 1 : 1);
			}
		}

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Subscription amount that users already had on purchase date').'</th>';
		$out[] = '<th width="1%" nowrap>'.JText::_('Users amount').'</th>';
		$out[] = '<th width="1%">'.JText::_('Date').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';


		$i = 1;
		$k = 0;
		$total = 0;
		foreach ($cols AS $date => $row)
		{
			foreach ($row as $subscr => $users)
			{
				if ($limit && $i > $limit) break;
				$k = 1 - $k;
				$out[] = '<tr class="row'.$k.'">
					<td>'.$i.'</td>
					<td>'.$subscr.'</td>
					<td align="center">'.count($users).'</td>
					<td nowrap>'.$date.'</td></tr>';
				$k ++; $i ++;
				$total += $subscr;
			}
		}

		$out[] = '</tbody></table>';

		$table = implode("", $out);
		if($params->get('rep_xls'))
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'member4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');

		if($params->get('plan'))
		{
			if(is_array($params->get('plan'))){
				$ids = implode(", ", $params->get('plan'));
			} else {
				$ids = $params->get('plan');
			}
		}
		else
		{
			$ids = false;
		}
		$sql = "SELECT COUNT(DISTINCT(s.user_id))
		FROM #__jcs_user_subscr s
		JOIN #__users u ON u.id = s.user_id
		WHERE s.published = '1' AND u.block = 0 AND s.ctime > '$from' AND s.ctime < '$to'".
		($ids ? " AND s.subscription_id IN ($ids) " : null);
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		//$sql .= "GROUP BY s.user_id";

		$db->setQuery($sql);
		$db_totals = $db->loadResult();

		$sql = "SELECT COUNT(*) as total, DAYOFMONTH(s.ctime) as mday, s.user_id, s.ctime,
		DAYOFYEAR(s.ctime) as sday,
		WEEKOFYEAR(s.ctime) as sweek,
		MONTH(s.ctime) AS smonth, YEAR(s.ctime) AS syear,
		DATE_FORMAT(s.ctime , '%d, %b') AS dat_sday,
		CONCAT('Week - ', DATE_FORMAT(s.ctime , '%U')) AS dat_sweek,
		DATE_FORMAT(s.ctime , '%b') AS dat_smonth 
		FROM #__jcs_user_subscr s		
		WHERE s.published = '1'".
		($ids ? " AND s.subscription_id IN ($ids) " : null)
		."AND s.ctime > '$from' AND s.ctime < '$to'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND s.user_id = '$user_id'";
		$sql .= "
		GROUP BY s.user_id, `{$groupby}`
		ORDER BY s.ctime";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result && !count($result)) return;

		$totals = array();

		foreach ($result AS $key => $row)
		{
			$index = $row->{"dat_".$groupby};
			$users[$index][] = $row->user_id;
		}

		$cols = array();
		foreach ($result AS $key => $row)
		{
			$index = $row->{"dat_".$groupby};
			$users[$index] = array_unique($users[$index]);
			switch ($groupby)
			{
				case 'sday':
					$query = " AND s.ctime < '".$row->ctime."'";
					break;
				case 'sweek':
					$query = " AND s.ctime < '".$row->ctime."'";
					$date = $row->syear.'-'.$row->smonth.'-'.($row->sweek);
					break;
				case 'smonth':
					$query = " AND s.ctime < '".$row->syear.'-'.$row->smonth.'-01'."'";
					break;
			}
			$sql = "SELECT COUNT(*) as total, s.user_id, s.ctime,
			DAYOFYEAR(s.ctime) as sday,
			WEEKOFYEAR(s.ctime) as sweek,
			MONTH(s.ctime) AS smonth, YEAR(s.ctime) AS syear
			FROM #__jcs_user_subscr s
			WHERE s.published = '1' AND s.user_id IN (".implode(', ', $users[$index]).")".
			($ids ? " AND s.subscription_id IN ($ids) " : null);
			if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND s.user_id = '$user_id'";
			$sql .= $query;
			$sql .= " GROUP BY s.user_id";
			$sql .= " ORDER BY s.ctime";
			$db->setQuery($sql);
			$res = $db->loadObjectList();

			if($res)
			{
				foreach ($res as $val)
				{
					$cols[$val->total][$val->user_id] = (isset($cols[$val->total][$val->user_id]) ? $cols[$val->total][$val->user_id] + 1 : 1);
				}
			}
			else
			{
				foreach($users[$index] as $user)
				$cols[0][$user] = (isset($cols[0][$user]) ? $cols[0][$user] + 1 : 1);
			}
		}
		if(!$db_totals && !count($cols)) return;

		$totals = array();

		$totals[0]['value'] = $db_totals.' <small><i>'.JText::_('user(s)').'</i></small>';
		$totals[0]['text'] = JText::_('got subscriptions in this report');

		$i = 1;
		ksort($cols);
		foreach ($cols as $subscr => $users)
		{
			if($i > 3) break;
			$totals[$i]['value'] = $subscr.' <small><i>'.JText::_('subscription(s)').'</i></small>';
			$totals[$i]['text'] = count($users).' '.JText::_('users had').' ('.(round(count($users) / $db_totals * 100, 2)).'%)';
			$i ++;
		}


		return $totals;
	}

}
?>